LTC = {};

---------
function LTC:OnLoad()
---------
	SLASH_LOST_TREASURE_CHECK1 = "/ltc";
	SlashCmdList["LOST_TREASURE_CHECK"] = function(msg) LTC:HandleSlashCommand(msg) end

	LTCFrame:RegisterEvent("PLAYER_LOGIN")
	LTCFrame:RegisterEvent("ADDON_LOADED")
end

---------
function LTC:OnEvent(self, event, ...)
---------
	local arg1, arg2, arg3, arg4 = ...
	if event == "ADDON_LOADED" and arg1 == "Lost Treasure Check" then
		LTCFrame:UnregisterEvent("ADDON_LOADED");
	elseif event == "PLAYER_LOGIN" then
		LTC:LoadData();
		LTC:LoadedNotify();
	end
end

---------
function LTC:LoadData()

	LTC_flags = {
		["Jade Forest"] = {
			["31402"] = { ["name"] = "Ancient Jinyu Staff", 					["itemID"] = "86196" },
			["31399"] = { ["name"] = "Ancient Pandaren Mining Pick", 			["itemID"] = "85777" },
			["31400"] = { ["name"] = "Ancient Pandaren Tea Pot", 				["itemID"] = "85780" },
			["31403"] = { ["name"] = "Hammer of Ten Thunders", 					["itemID"] = "86198" },
			["31307"] = { ["name"] = "Jade Infused Blade", 						["itemID"] = "86199" },
			["31401"] = { ["name"] = "Lucky Pandaren Coin",						["itemID"] = "85781" },
			["31865"] = { ["name"] = "Offering of Rememberance",				["itemID"] = nil	 },
			["31404"] = { ["name"] = "Pandaren Ritual Stone",					["itemID"] = "86216" },
			["31396"] = { ["name"] = "Ship's Locker",							["itemID"] = nil	 },
			["31866"] = { ["name"] = "Stash of Gems",							["itemID"] = nil	 },
			["31397"] = { ["name"] = "Wodin's Mantid Shanker", 					["itemID"] = "85776" }
		},

		["Valley of the Four Winds"] = {
			["31284"] = { ["name"] = "Ancient Pandaren Fishing Charm", 			["itemID"] = "85973" },
			["31292"] = { ["name"] = "Ancient Pandaren Woodcutter",				["itemID"] = "86079" },
			["31869"] = { ["name"] = "Boat-Building Instructions",				["itemID"] = nil     },
			["31406"] = { ["name"] = "Cache of Pilfered Goods",					["itemID"] = nil 	 },
			["31407"] = { ["name"] = "Staff of the Hidden Master",				["itemID"] = "86218" },
			["31405"] = { ["name"] = "Virmen Treasure Cache",					["itemID"] = nil 	 }
		},

		["Krasarang Wilds"] = {
			["31410"] = { ["name"] = "Equipment Locker",						["itemID"] = nil 	 },
			["31409"] = { ["name"] = "Pandaren Fishing Spear",					["itemID"] = "86124" },
			["31411"] = { ["name"] = "Recipe: Banana Infused Rum",				["itemID"] = "87266" },
			["31408"] = { ["name"] = "Saurok Stone Tablet",						["itemID"] = "86220" },
			["31863"] = { ["name"] = "Stack of Papers",							["itemID"] = "87798" }
			--["31863"] = { ["name"] = "Stack of Papers",							["itemID"] = nil	 }
		},

		["The Veiled Stair"] = {
			["31867"] = { ["name"] = "Forgotten Lockbox",						["itemID"] = nil 	 },
			["31428"] = { ["name"] = "Hammer of Folly",							["itemID"] = "86473" }
		},

		["Kun-Lai Summit"] = {
			["31420"] = { ["name"] = "Ancient Mogu Tablet",						["itemID"] = "86471" },
			["31414"] = { ["name"] = "Hozen Treasure Cache",					["itemID"] = nil 	 },
			["31413"] = { ["name"] = "Hozen Warrior Spear",						["itemID"] = "86394" },
			["31304"] = { ["name"] = "Kafa Press",								["itemID"] = "86125" },
			--["31304"] = { ["name"] = "Kafa Press",								["itemID"] = nil	 },
			["31418"] = { ["name"] = "Lost Adventurer's Belongings",			["itemID"] = nil 	 },
			["31868"] = { ["name"] = "Mo-Mo's Treasure Chest",					["itemID"] = nil 	 },
			["31419"] = { ["name"] = "Rikktik's Tick Remover",					["itemID"] = "86430" },
			["31412"] = { ["name"] = "Sprite's Cloth Chest",					["itemID"] = nil 	 },
			["31416"] = { ["name"] = "Statue of Xuen",							["itemID"] = "86422" },
			["31415"] = { ["name"] = "Stolen Sprite Treasure",					["itemID"] = nil 	 },
			["31421"] = { ["name"] = "Sturdy Yaungol Spear",					["itemID"] = "88723" },
			["31417"] = { ["name"] = "Tablet of Ren Yun",						["itemID"] = "86393" },
			["31422"] = { ["name"] = "Terracotta Head", 						["itemID"] = "86427" }
		},

		["Townlong Steppes"] = {
			["31427"] = { ["name"] = "Abandoned Crate of Goods",				["itemID"] = nil 	 },
			["31426"] = { ["name"] = "Amber Encased Moth",						["itemID"] = "86472" },
			["31423"] = { ["name"] = "Fragment of Dread",						["itemID"] = "86516" },
			["31424"] = { ["name"] = "Hardened Sap of Kri'vess",				["itemID"] = "86517" },
			["31425"] = { ["name"] = "Yaungol Fire Carrier",					["itemID"] = "86518" },
		},

		["Dread Wastes"] = {
			["31438"] = { ["name"] = "Blade of the Poisoned Mind",				["itemID"] = "86527" },
			["31433"] = { ["name"] = "Blade of the Prime",						["itemID"] = "86522" },
			["31436"] = { ["name"] = "Bloodsoaked Chitin Fragment",				["itemID"] = "86525" },
			["31864"] = { ["name"] = "Chest of Supplies",						["itemID"] = nil 	 },
			["31435"] = { ["name"] = "Dissector's Staff of Mutation",			["itemID"] = "86524" },
			["31431"] = { ["name"] = "Lucid Amulet of the Agile Mind",			["itemID"] = "86521" },
			["31430"] = { ["name"] = "Malik's Stalwart Spear",					["itemID"] = "86520" },
			["31432"] = { ["name"] = "Manipulator's Talisman",					["itemID"] = "86529" },
			["31437"] = { ["name"] = "Swarmkeeper's Medallion",					["itemID"] = "86526" },
			["31434"] = { ["name"] = "Swarming Cleaver of Ka'roz",				["itemID"] = "86523" },
			["31429"] = { ["name"] = "Wind-Reaver's Dagger of Quick Strikes",	["itemID"] = "86519" }
		}
	}

	LTC_location_order = {"Jade Forest","Valley of the Four Winds","Krasarang Wilds","The Veiled Stair","Kun-Lai Summit","Townlong Steppes","Dread Wastes"};

	LTC_total = LTC:CountFlags();
end

---------
function LTC:LoadedNotify(self)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."LostTreasureCheck |rloaded "..GREEN_FONT_COLOR_CODE..LTC_total.."|r items.");
end

---------
function LTC:HandleSlashCommand(cmd)
---------
	if string.lower(cmd) == "all" then
		LTC:CheckFlags(true);
	else
		LTC:CheckFlags(false);
	end
end

---------
function LTC:CountFlags()
---------
	local count = 0;
	for loc,ids in pairs(LTC_flags)
	do
		for _ in pairs(LTC_flags[loc])
		do
			count = count + 1;
		end
	end
	return count;
end

---------
function LTC:CheckFlags(showAll)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: |r");
	DEFAULT_CHAT_FRAME:AddMessage("---------------------------|r");
	if LTC_location_order then
		local completed = 0;
		-- Retrieve locations
		for index, loc in pairs(LTC_location_order)
		do
			completed = completed + LTC:CheckLocation(loc, showAll);
		end
		DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Treasures Found: |r"..completed.."/"..LTC_total);
	end
end

---------
function LTC:CheckLocation(loc, showCompleted)
---------
	local completed = 0;
	local total = 0;
	local isCompleted = {};
	local ordered_flags = {};

	-- Retrieve quest flag IDs by location
	if(LTC_flags[loc]) then

		-- Check if each flag is completed and increment counts
		for id,info in pairs(LTC_flags[loc])
		do
			total = total + 1;
			if IsQuestFlaggedCompleted(id) == 1 then
				isCompleted[id] = true;
				completed = completed + 1;
			else
				isCompleted[id] = false;
			end;
			-- Insert flag IDs into a list for sorting later
			table.insert(ordered_flags, id);
		end

		-- Sort flag IDs to maintain order
		table.sort(ordered_flags);

		-- Only print this location's header if we have flags to display
		if showCompleted or (total - completed) > 0 then
			-- Print location and (completed / total) count
			DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE..loc.."|r ("..completed.."/"..total.." found): ");

			-- Print each flag, completed status, and an item link if relevant
			for index,questID in pairs(ordered_flags)
			do
				local c = isCompleted[questID];
				local itemID = LTC:GetItemID(loc, questID);

				local link;
				if itemID ~= nil then
					link = LTC:GetItemLink(itemID);
				end

				if not link then
					link = LTC:GetFlagName(loc, questID);
				end

				if c then
					if showCompleted then
						DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..GREEN_FONT_COLOR_CODE.."Found |r");
					end
				else
					DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..RED_FONT_COLOR_CODE.."Missing |r");
				end
			end

			DEFAULT_CHAT_FRAME:AddMessage("\n");
		end
	end

	return completed;
end

---------
function LTC:GetItemID(loc, questID)
---------
	return LTC_flags[loc][questID]["itemID"];
end

---------
function LTC:GetFlagName(loc, questID)
---------
	return LTC_flags[loc][questID]["name"];
end

---------
function LTC:GetItemLink(itemID)
---------
	if itemID then
		--DEFAULT_CHAT_FRAME:AddMessage("Finding link for itemID = "..itemID);
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
		if not itemLink then
			return nil;
		else
			return itemLink;
		end
	else
		--DEFAULT_CHAT_FRAME:AddMessage("itemID = nil");
		return nil;
	end
end